#!/usr/bin/env python
# coding: utf-8

from datetime import datetime
from multiprocessing import Pool

import sys

import smartcarb as sc
import config


def run(a):
    sc.level2.main(*a)

if __name__ == '__main__':

    starttime = datetime(2015,1,1)
    stoptime = datetime(2015,1,19)
    #starttime = datetime(2015,7,1)
    #stoptime = datetime(2015,7,19)

    lon_eq = 0.0 # [0.0, 90., 18.0, 270.0, etc.]


    #instrument = 'Sentinel_5'
    #instrument = 'Sentinel_7_CO2'
    #instrument = 'Sentinel_7_NO2_1km' # FIXME: not working because pixel might be too small?
    #instrument = 'Sentinel_7_NO2_2km'
    #instrument = 'Sentinel_7_NO2_4km'
    instrument = sys.argv[1]
    print(instrument)

    # create args
    args = []
    for starttime, stoptime in [
        (datetime(2015,1,1), datetime(2015,1,19)),
        (datetime(2015,7,1), datetime(2015,7,19)),
        ]:
        for lon_eq in [0.0, 90.0, 180.0, 270.0]:
            if instrument == 'Sentinel_5':
                istart = sc.level2.date2orbit(starttime, 'Sentinel_5')
                istop = sc.level2.date2orbit(stoptime, 'Sentinel_5')
            else:
                istart = sc.level2.date2orbit(starttime, 'Sentinel_7')
                istop = sc.level2.date2orbit(stoptime, 'Sentinel_7')

            print(istart, istop)

            args += [
                (
                    instrument, number, None, # all tracers plus clouds
                    config.path_orbits,
                    config.path_2d_fields,
                    config.path_level2_data,
                    lon_eq
                )
                for number in range(istart, istop)
            ]
    args.sort()
    print('#orbits: %d' % len(args))

    #for arg in args:
    #    print(arg[0], arg[1], arg[-1])

    # start
    pool = Pool(processes=12)# (reduce to have enough memory)  config.nproc) 
    pool.map(run, sorted(args))



